(function () {
    'use strict';
    $dyn.ui.defaults.PIMCopyControlTwo = {};

    $dyn.controls.PIMCopyControlTwo = function (data, element) {
        var self = this;

        $dyn.ui.Control.apply(self, arguments);
        $dyn.ui.applyDefaults(self, data, $dyn.ui.defaults.PIMCopyControlTwo);

        self.copyElementsCallBack = function (_sJSON) {
            navigator.clipboard.writeText(_sJSON);
        }
    }

    $dyn.controls.PIMCopyControlTwo.prototype = $dyn.extendPrototype($dyn.ui.Control.prototype,
    {
        init: function (data, element) {
            var self = this;
            $dyn.ui.Control.prototype.init.apply(this, arguments);

            var elemmList = document.getElementsByName('PIMCopyProductsTwo');
            var lastElementId = elemmList.length;
            var elemm = elemmList[lastElementId-1];
            elemm.onclick = function () {
                $dyn.callFunction(self.copyElements, self, {}, self.copyElementsCallBack);
            };
        }
    });

    // Keep track of clicked keys
    var isKeyPressed = {
        q: false, // ASCII code for 'a'
        w: false // ASCII code for 'b'
        // ... Other keys to check for custom key combinations
    };

    document.onkeydown = keyDownEvent => {
        //Prevent default key actions, if desired
        //keyDownEvent.preventDefault();

        // Track down key click
        if (keyDownEvent.key == "q" || keyDownEvent.key == "w") {
            isKeyPressed[keyDownEvent.key] = true;
        }

        // Check described custom shortcut
        if (isKeyPressed["q"] && isKeyPressed["w"]) {
            var elemm = document.getElementsByName('PIMCopyProductsTwo')[0];
            if (elemm) { elemm.click(); }
        }
    };

    document.onkeyup = keyUpEvent => {
        // Prevent default key actions, if desired
        //keyUpEvent.preventDefault();

        // Track down key release
        if (keyUpEvent.key == "q" || keyUpEvent.key == "w") {
            isKeyPressed[keyUpEvent.key] = false;
        }
    };

})();